define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'users/bankcard/index' + location.search,
                    add_url: 'users/bankcard/add',
                    edit_url: 'users/bankcard/edit',
                    del_url: 'users/bankcard/del',
                    multi_url: 'users/bankcard/multi',
                    import_url: 'users/bankcard/import',
                    table: 'bank_card',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'user_id', title: __('User_id')},
                        {field: 'name', title: __('Name'), operate: 'LIKE'},
                        {field: 'bank_name', title: __('Bank_name'), operate: 'LIKE'},
                        {field: 'bank_num', title: __('Bank_num'), operate: 'LIKE'},
                        {field: 'open_address', title: __('Open_address'), operate: 'LIKE'},
                        {field: 'identity_on', title: __('Identity_on'), operate: 'LIKE'},
                        {field: 'identity_off', title: __('Identity_off'), operate: 'LIKE'},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});
